package slog

import (
	"io"
	"os"
	"sync"
)

type StdoutLogger struct {
	w io.WriteCloser
	m sync.Mutex
}

func (s *StdoutLogger) Write(p []byte) (n int, err error) {
	s.m.Lock()
	defer s.m.Unlock()

	return s.w.Write(p)
}

func (s *StdoutLogger) Close() error {
	s.m.Lock()
	defer s.m.Unlock()

	return s.w.Close()
}

func NewStdoutLogger() io.WriteCloser {
	ret := &StdoutLogger{}
	ret.w = os.Stdout

	return ret
}
